Editorial for Zeroes


Remember to use this editorial only when stuck, and not to copy-paste code from it. Please be respectful to the problem author and editorialist.
Submitting an official solution before solving the problem yourself is a bannable offence.

Author: Sucram314

It is highly encouraged for you to attempt the problem first, and only use this editorial if you are completely stuck. You'd be surprised how far you can get with sheer persistence!

Note: You should read a previous hint before a later one so as to not miss any definitions or important details.

Subtask 1

Hint 1 Do we really have to multiply numbers? Is there a better way to count the number of trailing zeroes in a product of integers?
Hint 1 Answer The number of trailing zeroes in a positive integer x is maximum k such that 10k divides x evenly. The number 10 can be split into its prime factors, 2 and 5, so k is the minimum of the exponents on 2 and 5 in the prime factorization of x.

We can write this more compactly with p-adic valuation as min(ν2(x),ν5(x)). Using the property that νp(xy)=νp(x)+νp(y), the number of leading zeroes in the product of the subarray from index l to r is min(ν2(al)+ν2(al+1)++ν2(ar),ν5(al)+ν5(al+1)++ν5(ar)) To precompute the values of ν2(ai) and ν5(ai) for all i, we can use a while loop that counts the number of times we can divide ai by 2 until it is no longer divisible by 2, and a similar while loop for 5. The maximum number of times that this while loop will run for a single number is given by log2(max(ai))=log2(109)=29, so speed is not a concern.
Hint 2 Is there a faster way to find the sum of ν2(ai) and ν5(ai) in a subarray without looping through it?
Hint 2 Answer After precomputing ν2(ai) and ν5(ai) for all i, we can use prefix sum arrays to find the sum of ν2(ai) or ν5(ai) in a subarray in O(1) time.
Implementation First, we precompute ν2(ai) and ν5(ai) for all i. Since 1N5000 in this subtask, looping through all subarrays is feasible. We can use prefix sum arrays to quickly calculate the sums of ν2(ai) and ν5(ai) in each subarray and take the minimum out of the two.

More formally, define c2[i]=ν2(a1)+ν2(a2)++ν2(ai) and c5[i]=ν5(a1)+ν5(a2)++ν5(ai), and c2[0]=c5[0]=0. Thus, c2 and c5 are the prefix sum arrays of ν2(ai) and ν5(ai), respectively. The answer is given by 0l<rNmin(c2[r]c2[l],c5[r]c5[l]) Time Complexity: O(Nlog(max(ai))+N2)

Subtask 2

Hint 1 The min function in our sum is difficult to optimize. Is there way to break min(x,y) into two pieces which are easier to calculate?
Hint 1 Answer The min function can be broken into two pieces: min(x,y)=12((x+y)|xy|) Thus, we can rewrite our desired sum into two separate sums: 0l<rNmin(c2[r]c2[l],c5[r]c5[l])=0l<rN12((c2[r]c2[l]+c5[r]c5[l])|(c2[r]c2[l])(c5[r]c5[l])|)=12[(0l<rNc2[r]c2[l]+c5[r]c5[l])(0l<rN|(c2[r]c2[l])(c5[r]c5[l])|)]
Hint 2 Group the terms in the first sum by index: 0l<rNc2[r]c2[l]+c5[r]c5[l]=0l<rN(c2[r]+c5[r])(c2[l]+c5[l]) How many times do the contributions from a certain index i get added (or subtracted) in this sum? Can we use this to get rid of the summation through pairs (l,r)?
Hint 2 Answer We can define a single contribution from index i to be c2[i]+c5[i]. We can consider two cases, one where i is the "r" in the sum, and one where i is the "l".

Every time i is the right endpoint in the sum, r, its contribution is added to the sum. The number of times this happens is the number of possible l which could have their corresponding l equal to i, which is |[0,i1]|=i. Thus, the total contribution from this case is (c2[i]+c5[i])i.

Every time i is the left endpoint in the sum, l, its contribution is subtracted from the sum. The number of times this happens is the number of possible r which could have their corresponding l equal to i, which is |[i+1,N]|=Ni. Thus, the total contribution from this case is (c2[i]+c5[i])(Ni).

Adding these together to find the total contribution of index i, we get (c2[i]+c5[i])i (c2[i]+c5[i])(Ni)=(c2[i]+c5[i])(2iN) This gives us a neat expression for the contribution of a certain index i to the sum. We can rewrite the sum over indices i instead of pairs (l,r) now: 0l<rNc2[r]c2[l]+c5[r]c5[l]=i=0N(c2[i]+c5[i])(2iN)
Hint 3 The absolute value bars in our second sum are difficult to optimize. However, remember that |xy|=|yx|. What does this mean we can do to our sum to make it easier to calculate?
Hint 3 Answer Again, we group terms by index. 0l<rN|(c2[r]c2[l])(c5[r]c5[l])|=0l<rN|(c2[r]c5[r])(c2[l]c5[l])| Since |xy|=|yx|, swapping two adjacent indices i and i+1 would have no effect on the sum. Swapping two adjacent indices can be done repeatedly to slowly transform the array into any permutation we want, and the sum will still be the same.

Thus, we can sort the indices by c2[i]c5[i] and be sure that (c2[r]c5[r])(c2[l]c5[l]), which allows us to completely remove the absolute value bars from our sum.

More formally, define σi as a permutation of [0,N] that is sorted by c2[i]c5[i]. 0l<rN|(c2[r]c2[l])(c5[r]c5[l])|=0l<rN(c2[σr]c2[σr])(c2[σl]c2[σl]) Finally, we can optimize the calculation of this sum with the same trick used for the other piece of the original sum.
Implementation Again, we precompute ν2(ai) and ν5(ai) for all i, and build prefix sum arrays, c2 and c5, so that c2[i]=ν2(a1)+ν2(a2)++ν2(ai) and c5[i]=ν5(a1)+ν5(a2)++ν5(ai), and c2[0]=c5[0]=0.

Then, we can create two arrays, s[i]=c2[i]+c5[i] and d[i]=c2[i]c5[i]. Sort d in ascending order.

The answer is given by 12i=0N(s[i]d[i])(2iN) Time Complexity: O(Nlog(max(ai))+NlogN)

Comments

There are no comments at the moment.